Как стать автором
Обновить

Комментарии 74

Похоже на заговор разработчиков и производителей железа.
Да, ладно вам, какой заговор — обычное головотяпство и нехватка ресурсов. Гугл торопился захватить рынок до Эпла и лепил недоделанные релизы Андроида, производители железа не успевали за Гуглом и ставили старые версии ОС, лишь бы побыстрей выпустить новые железяки, а разработчикам лень не хватает времени и денег, чтобы всё это поддерживать.
Это не заговор, это прогресс. Глупо отказываться от удобных функций и средства разработки только потому, что Google в свое время не смог ни придумать ни проконтролировать механизма массового обновления системы.
что Google в свое время не смог ни придумать ни проконтролировать механизма массового обновления системы

Придумать и проконтролировать — раз плюнуть. Только это будет вступать в противоречия со свободами Android. В этом случае Google должна запретить вендорам лазить в ядро, фреймворки, ставить модифицированные либы и прочая-прочая-прочая. Пример такой есть — Google Nexus и Google Play Edition. Или ещё более наглядный пример — Chrome OS. Чем устройства на Chrome OS отличаются друг от друга? Только шильдиком и железкой. Обновления прямо от Google, минуя всех вендоров.
Когда я писал приложения, то посмотрел статистику и увидел, что на тот момент владельцев с Андроидом версий меньше 3.0 было около 20%
Прикинув усилия, которые мне нужно было приложить, чтобы у этих 20% всё работало также, как и у продвинутых 80%, я решил, что разумнее было сделать minSdkVersion=14
Лично мне это выгоднее
* так же
Добавлю, что эти 20% пользователей с устаревшей версией Андроида очень сильно попортили мне рейтинг. Когда я их перестал поддерживать и просто-напросто отключил, то рейтинг поднялся, закачки возросли и все были довольны.
Нам в свое время надо было переделывать iOS приложение, написанное на iOS5, для новой операционки iOS7. Встала речь о том, что нужно поддержать iOS6. Юзеров с iOS6 у нас было около 25%. Однако повторять функционал iOS7 библиотек для поддержки 6-ой версии, по прикидкам, надо было в течение пары недель. А это и стоимость (лишних несколько тысяч долларов), и более поздний выход релиза приложения.

Поэтому волевым усилием решили забить на поддержку iOS6, и сделать сразу приложение только под iOS7. Практика показала — что не ошиблись. Оттока не было, сейчас доля iOS6 мнее 5%, люди пользуются старым приложением.

Мы сэкономили деньги и время.

Так что заговора нет — чистая и прагматичная экономика.
С iOS это немного проще. Политика Apple сильнее заставляет пользователей обновлять телефоны до новой iOS (будь то обновление самой iOS или всего телефона), поэтому пользователи старых iOS намного быстрее уходят если сравнивать с Android.
Тут двояко. Эппл заставляет обновить ось на той же железке. Я бы и рад обновиться со своего андроида 2.3 на 4 (железка не самая слабая, потянула бы), но нет. 2.3 — последняя доступная версия для моей железки. Есть, конечно, и фанатские поделки 4й версии под мой телефон, но там временами вылезают глюки. Вроде неработающей камеры, например.
Яблоко больше предпочитает обновить саму железку, по этой причине на старом железе нельзя обновится так же, как и со старыми Android аппаратами.
Например, старый iPad 1 остался на iOS 5, а iPhone 3Gs не может прыгнуть выше iOS 6.
Возможно, iPad 1 и потянул бы iOS 6 в своё время, но надо ведь продавать более новое железо. Впрочем, кроме денег обычно пользователь выигрывает при покупке нового железа.
Вот уж в чём-чём, а в этом-то Apple упрекнуть можно в последнюю очередь. Устройства на Android в подавляющей массе теряют поддержку обновлений куда раньше, поскольку производители их в основном зарабатывают именно на железе, но не на сопутствующих сервисах.
Да, но сравнение не совсем корректное.
Уровень апи не повысится, но у Apple все плюшки привязаны к выходу нового мажорного релиза, а на андроиде компоненты обновляются независимо от этого.
Например, вышло обновление google play serviceИ и телефоны получили функцию отслеживания и удалённого блокирования; придумали что-то новое для магазина и обновили на все устройства, в том числе и на 2.* ветку. И так со многими компонентами.
Вот есть у меня старый айпад 1, но я на него не могу поставить карты от Apple, пользоваться iMessage и это только потому, что нужно обновить прошивку для новых функций, которые в сторонних программах легко обновляются.
Неверно.
Как, например, запустить Google Keep или Chrome на Android 2.3?
Я правильно понимаю, что у вас что-то с глазами и вы слова «многие» и «все» не отличаете? Тот факт, кто Google решил совету из обсуждаемой статьи ничего не меняет.

Да, Google Chrome и Google Keep на Android 2.3 не встают. Но они встают на любой телефон с Android 4.0 и могут быть обновлены независимо от всего остального, что там есть. А многие другие системные приложения до сих пор и на телефонах с Android 2.3 обновляются (те же Google Hangouts, к примеру).
Я правильно понимаю, что у вас что-то с глазами и вы слова «многие» и «все» не отличаете?

Приложения Google — это не большая, а в большинстве случаев наслоений bloatware от OEM — меньшая часть прошивки. То, что мне там Google Hangouts обновили, вместо дырок в WebKit или в OpenSSL — от этого не легче. Вот когда Google будет обновлять либы через Play Services — тогда можно об этом восторженно говорить.
Да, Вы правы. В мире Apple такие решения действительно принимать проще.
Заминусуют конечно, но меня вот 4-й андроид просто злит внешне. Не могу себя заставить привыкнуть к этом идиотским иконкам, а нормального лаунчера похожего внешне на 2.3 найти пока не удается. Терплю, но злит… К тому же на старом каптивейте мне жуткими ухищрениями удавалось заставить 2.3 потреблять 34 mW в режиме ожидания. А с четверкой на этом же телефоне так и не получилось снизить ниже 85 mW. Это при том, что для этого телефона стоковая 2.3 потребляла 480 mW, а стоковая 4 — 290 mW
попробуйте aviate, он хорош, при выключенных настройках локации, правда и привыкать к нему надо. Сижу уже на нем давно, ничего другого и не надо, все очень удобно если настроить.
Дайте угадаю, а на компе у вас стоит Windows XP?
Хороший наброс :) Не знаю, как у автора комментария, а у меня W8.1 и меня обескураживает, почему ноутбук включается и готов к работе быстрее, чем запускается планшет с 4 ядрами и 2 гигами памяти… И да, ноутбук в standby, кажется, протянет дольше на одной батарее.
>нормального лаунчера
>похожего внешне на 2.3

Что? 0_о

Дефолтный 4.4 (да и вообще вся четверка) выглядит настолько лучше 2ки, что я даже сравнивать постеснялся, ей богу. Я понимаю, что красота и удобвство вещи во многом субъективные, но мне все равно не понятно, как может нравится уродство старых версий дройда. Там даже кастомые лаунчеры\оболочки HTC слабо спасали ситуацию же.
А с помощью чего вы фиксируете потребление в mW?
Я же говорю что заминусуют, начнут навязывать и говорить что значки четверки в 100 раз лучше :)
А ведь я не говорил что они хуже — я просто сказал что мне они не нравятся :)
А расход батарейки в покое измеряю в PowerTutor за ночь и отнимаю от общей цифры расход самого PowerTutor
Интересно было бы услышать, чем руководствуются люди, выставляющие минимальную версию api в 19 (таких, на момент написания комментария, ровно 19 человек). Они разрабатывают несколько версий продукта, каждая под свою версию api, или же от поддержки остальных версий api было решено отказаться?
Ну как минимум есть ещё электронные книги, на которых обновить Android не получится…
НЛО прилетело и опубликовало эту надпись здесь
Я очень расстроился, когда любимая софтина для просмотра комиксов (Perfect View) перестала поддерживать Android 2.1. Манги прочитал со своего Nook'a много. Также программу для отложенного оффлайн чтения собранных интернет-страниц было найти тяжело. Пока есть InstaFetch, но если и его перестанут поддерживать — будет совсем тяжко.
Конечно, как минимум — электронный словарь, поддержка карт для изучения слов (такая функциональность например, встроена в последнюю прошивку Kindle).
Да и «сами книги» — это не так просто, многие программы чтения пишутся изначально для планшетов или сматрфонов, а потом уже энтузиастами портируются на eInk, так что автор такой программы, в принципе, легко может выставить Android 4 в требованиях, и привет.
Дополнительно пользуюсь старой планшеткой/читалкой как интернет-радиоприёмником. Версии 2.1 хватает выше крыши. Есть и «кастом» версии 1.99 ;), чего также хватает для всего, в том числе и админить серваки. А вообще к этой оси отношусь.., скажем так, очень критически.
Они прост работают в Google и разрабатывают AOSP. :)
Например, в Android 4.4 появилась встроенная запись экрана. Авторы программы Rec. используют системную функцию, их приложение только 4.4+. Может, это ее разработчики набежали?) Возможно, есть нечто подобное и в других отраслях. Типа системных твиков для Kit Kat и тю д.
Когда пишу проэкт-хобби, то не заморачиваюсь поддержкой разных версий Андроид.
Напоминает историю IE и конкретно IE6.

Да какая история, у нас есть один юзернейм, который до сих пор периодически жалуется на что-то неработающее на сайте для IE6.
В одном из мест, где мне довелось работать (4 года назад), по требованию службы безопасности разрешен был только IE6. Все конечно понимали, что жаловатся на «кривые сайты» глупо. Но меня раздражали сайты, которые сразу редиректили на страницу «у вас устаревший браузер, установите новый» — я понимаю, что что-то может не работать, но показать хотя бы номер телефона или емейл было бы логично.
С первого релиза приложения поставил 16, а потом 15.
И как-то не сильно прибавилось пользователей.
Самое интересное 50% это Android 4.4 и это радует.
Никакой социальной ответственности, только бизнес.
Подталкивать людей к покупке новых смартфонов — это и есть социальная ответственность, ведь новыми покупками люди не дают экономике стагнировать — на одном смартфоне зарабатывает куча людей: продавец, доставщики, маркетологи, сборщицы на конвейере в Китае, программисты и т.п. и т.д. — им всем тоже нужно есть и кормить свои семьи! Только представьте себе, что было бы, если бы все люди довольствовались тем, что у них есть, и не стремились к лучшему — экономика бы встала, наступила бы новая Великая Депрессия!
Неделя маркетолога официально объявляется открытой.
НЛО прилетело и опубликовало эту надпись здесь
Кастомы ставили?
Дело в том что в кастомах типа CyanogenMod и.т.д в ядре куча хаков что бы нормально работало со старыми блобами, соотвественно камера не снимает так как положено артефачит. Драйвера для GPU вообще больная тема у кастом шефов.
Если блоб был бы скомпилирован из сорцов с учётом апи 4.1 — 4.4 то всё было бы даже лучше чем на 2.3.
В 4.1 ввели Project Butter. А 4.4 вообще нормально работает на 512 мб RAM и 1ггц процессор.
Да что тут уже говорить посмотрите даже на тот же самый HTC HD2, там уже переписали и реверснули всё что только возможно, даже ВинФон запустили.
Еще тот же самый HTC Hero, до сих пор жив, и я со своим HTC One X завидую коммунити Hero, так как там кастомов нормально работающих — тонна.
НЛО прилетело и опубликовало эту надпись здесь
Отчасти они правы. У меня андроид 2.3 версия. Выше уже обновить нельзя, так как нет обновления для него. Первоначально установил набор программ для него и забыл. Так как не играю в игрушки на телефоне, а за место переписки предпочитаю сделать звонок. И скорее я куплю себе уже новый телефон, чем буду оживлять этот и что-то в нем грейдить.
Вот как можно решить проблему стикерами. :-)
НЛО прилетело и опубликовало эту надпись здесь
Читал со смешанными чуствами — с одной стороны как разработчик, я хочу просто писать под новое API и не тратить ресурсы на совместимость. С другой стороны у меня Desire S на 2.3.5, который мне нравится и переходить на что-то другое в ближайшее время не собираюсь.
Склоняюсь к тому, что с призывом «писать только под 14» скорее согласен — владельцы старых устройств, вроде меня, менее склонны ставить новые программы. Максимум приложений я установил в первые пару месяцев после покупки телефона. С точки зрения бизнеса полностью оправдано тратить ресурсы только на то, что приносит доход.
Как исключение я бы назвал массовые приложения вроде карт и расписания поездов — вот там логично потратить чуть буольше усилий и поддерживать всё что есть на рынке.
В целом с посылом статьи согласен, но очень не хочется страдать из-за того, что у меня на устройстве четвёртый андроид подтупливает. Ну и выбрасывать телефон только потому что операционка на нём устарела мне тоже кажется неправильным.
Chainfire (наверняка известный многим владельцам Galaxy-девайсов хакер) тут пару месяцев назад написал похожие посты про Gingerdeath. Gingerbread с 19% официальной доли принёс ему 2% доходов, тогда как KitKat с 5% доли принёс 48% доходов.
У меня пылится когда-то довольно неплохой HTC Desire с официальным 2.2. Принцип отладки и тестирования игр такой: заточить проект под Xoom и др. современные железки, а затем проверить, тормозит ли на Desire. Если тормозит, значит что-то пошло не так — этого устройства хватает на некоторые 3д игры, фулскрин видео, 60 fps в OpenGL 2D прогах с собственным оконным интерфейсом. И пусть хоть Android 7.0 выйдет, пока я не шагну на следующую ступень графики (3д игры с реал-тайм светом и мягкими тенями?), маскировать собственные недоработки под минимальные требования не собираюсь.
А я до сих пор пользуюсь HTC Desire (правда с 2.3) и не очень понимаю, чем его сейчас можно заменить.
Странно то, что мне хочется купить современный аппарат, но 1в1 как Desire: с таким же корпусом, оптическим трекболом, весом, временем работы. Он далеко не был идеален в этих качествах, но реально опасаюсь взять девайс хуже — их полно на рынке, с Full HD при 3.5-4", 0.5 дня работы с одного заряда и прочими бедами.
Вот и мне хочется того же самого, а его нету. Поэтому до сих пор на Desire.
LG G2 живет 2-3 дня активного использования. С fullHD
К сожалению по СНГ пока таких телефонов 11-13 %
Принимать решение можно только основываясь на своей статистике и количестве костылей
(но большая часть приложений обходится android.support без сторонних библиотек)
А не на авторитетных советах.

Вот если в приложении еще нет аудитории — нечего и думать: конечно >=14
Вот если в приложении еще нет аудитории — нечего и думать: конечно >=14

А можно же наоборот?
Выкатить версию, посмотреть на число пользователей, а потом обрезать совместимость если что.
Те, кто уже установил ничего не потеряют (кроме новых фич), а вам дальше разрабатывать проще.
Если планируется использование новинок — то совместимость надо сначала обеспечить, протестировать и т.д. — потратить кучу ресурсов изначально. И усложнить софт сразу. Если ради того, чтобы понять что «можно вырезать» — бесполезная трата сил.
Если пока что новые фичи не нужны и можно получить совместимость «задаром» — тут надо думать. Ведь в будущем отказав в обновлениях тем, у кого старая версия, вы расстроите своих пользователей. Иногда не дать им ничего изначально — лучше.
И еще есть приложения, для которых нельзя просто так оставить старые весрии без обновлений. Тот же банковский софт, например.
Выше вот ответили верно.
Без поддержки приложение не просто не получает новых фич — оно рано или поздно перестает работать
Так уже бывает… Не знаю почему, но программы реально могут дряхлеть и помирать, если за ними нет ухода.

А пользователи вспоминают о вас только, когда у них плохо, а не когда все хорошо.
И идут вам ставить свой кол в Google Play, сдобрив комментарием «на счет тупых разрабов».

Ровно также в число первых пользователей могут попасть и ваши лояльные первопроходцы.
Потому лучше не экспериментировать, а сразу принимать решение в зависимости от проекта.
дабы статистика и так доступна.

Столько народу еще на 2.3, думал таких «динозавров» как у меня осталось не много)
Мой 4ех летний ZTE и не думает помирать :)
Аналогично с Desire S — к слову, еще даже есть в продаже. Я бы может уже и поменял, но покажите мне телефон с металическим корпусом, экраном менее 4 дюймов и приличной начинкой.
покажите мне телефон с металическим корпусом, экраном менее 4 дюймов и приличной начинкой.

iPhone 5s O_o
А если серьезно — зачем вам меньше 4"? Я вот перешел на 4.5" (Xiaomi MI2 A) — идеально. Можно одной рукой пользоваться, комфортно читать и т. д. и т. п.
Предвидел ответ про айфон, но решил что в теме про Android 2.3 vs Android 4.4 можно не уточнять, что хочу Android :)
Зачем — потому что удобнее лежит в руке и в кармане. То есть я не собираюсь убеждать, что это лучшая ОС и лучший размер — я за разнообразие, где я возьму то что удобно мне, а Вы — то что удобно Вам.
Про айфон была шутка. Сарказмометр, видимо, таки нужен :)
Вспомнил — есть такой девайс: Sony Xperia P. Начинка, конечно, не топовая на сегодняшний день, но получше дезайра.
4" qHD, 120 грамм, аллюминий и пластик в корпусе, камера 8 МП, проц от Сони фирменный и видео мали-400. До 4" лучше железо не отыскать ни сейчас, ни, думаю, тем более, в будущем.
Как то не нравится мне дизайн большинства смартфонов от HTC и Sony. Аж до того что даже игнорирую их «начинку» ))
Мое исключительно субъективное мнение :)
Мне не особо важен корпус. Просто трубка покрывает все потребности — связь, навигация, интернет и фото (3,5мп, весьма сносное).
Главный минус — заряда хватает только на день.
Я, конечно, активно использую планшет, а вот дядя только смартом пользуется. И как -то не жалеет, что с HTC desire перешел на One X, а потом на LG G2. Заряжает лыжу даже не каждый день, хотя с телефона ведет деловую переписку, много звонит, в том числе по виберу/хенгаутсу, слушает музыку, читает новости, даже документы, бывает, правит, юзает GPS для машины/endomondo. Так что размер кармана телефона — это то, чем приходится жертвовать. Хотя я не скажу, что он скучает по 3.7". А я по 3.2 так тем более.
При старте разработки Хабрахабра в ноябре мы даже не задумывались о поддержке 2.3. Сразу стартовали с 4.0. Ох сколько времени и нервов сберегли :)

Сейчас все новые продукты тоже только с 4.0.

Табличку Гугла не люблю о % платформ. Она не отражает текущую ситуацию в вашей нише, это точно. А если говорить о платежеспособности аудитории на 2.3, то тот процент, который вам нужен, там еще ниже.
Что-то вы лукавите по поводу того, что даже не задумывались

Часть хабраюзеров спрашивала, за что же так обделили вторую версию Android. Изначально приложение разрабатывалось с поддержкой Android 2.3.3+. По ходу разработки на ровном месте появлялись проблемы, связанные именно с этой платформой. Нас это не останавливало — исправляли, местами даже приходилось писать весьма костыльные решения. Но во время тестирования появлялись всё новые и новые баги, да и затраты на тестирование возрасли в два раза. Поэтому в условиях приближающегося релиза было решено отказаться от поддержки тех 10% устройств под управлением Android ниже 4.0.


habrahabr.ru/company/cleverpumpkin/blog/221329/
Кстати в новой версии Android Studio 0.6.1 по умолчанию теперь предлагают сразу API 15.



Обновил информацию у себя. Как видите, разработчиков начинают подталкивать в этом направлении.
Официальное приложение ВКонтакте прекратит поддержку 2.х со следующего обновления, например. Только 4.0+. Выкинул кучу библиотек совместимости и не жалею :)
Не поддерживал версий < 4.0 до того как это стало мейнстримом.
А можно ссылку на оригинал? Отправлю американским боссам :)
Обычно ссылка на оригинал находится рядом с ником переводчика под постом)
Спасибо.
Только полноправные пользователи могут оставлять комментарии. Войдите, пожалуйста.